#include <bits/stdc++.h>
#define int long long
using namespace std;
int n,k,a[1048576],ans=0,p[20];
void print()
{
    int o=0,br=0;
    for(int i=1;i<=n;i++)
    {
        o=o|a[i];
        int lamp=0;
        for(int j=0;j<15;j++)
        {
            if(p[j]&&(o&(1<<j))==0)
            {
                lamp=1;
                break;
            }
        }
        if(!lamp)
        {
            br++;
            o=0;
        }
    }
    int val=0;
    for(int j=0;j<15;j++)
    {
        if(p[j])val+=(1<<j);
    }
    if(br>=k)
    {
        ans=max(ans,val);
    }
}
void rek(int pos)
{
    for(int i=0;i<2;i++)
    {
        p[pos]=i;
        if(pos==11)print();
        else rek(pos+1);
    }
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>k;
    for(int i=1; i<=n; i++)cin>>a[i];
    rek(0);
    cout<<ans<<endl;
    return 0;
}
